// Generated by CoffeeScript 2.5.1
(function() {
  var ClickHouse, NUM_OF_LINE, STATEMENT_CREATE_TABLE, STATEMENT_DROP_TABLE, STATEMENT_SELECT, TABLE_NAME, assert, columnValueString, createCargo, crypto, debuglog, fs, getClickHouseClient, isInited, os, path;

  ({createCargo, isInited} = require("../"));

  debuglog = require("debug")("chcargo:test:04");

  assert = require("assert");

  crypto = require('crypto');

  fs = require("fs");

  os = require("os");

  path = require("path");

  ClickHouse = require('@apla/clickhouse');

  TABLE_NAME = "cargo_test.unittest04";

  STATEMENT_CREATE_TABLE = `CREATE TABLE IF NOT EXISTS ${TABLE_NAME}
(
  \`time\` DateTime ,
  \`step\`  UInt32,
  \`pos_id\` String DEFAULT ''
)
ENGINE = Memory()`;

  STATEMENT_CREATE_TABLE = STATEMENT_CREATE_TABLE.replace(/\n|\r/g, ' ');

  columnValueString = Date.now().toString(36);

  STATEMENT_DROP_TABLE = `DROP TABLE IF EXISTS ${TABLE_NAME}`;

  STATEMENT_SELECT = `SELECT * FROM ${TABLE_NAME} WHERE pos_id='${columnValueString}' LIMIT 100000 FORMAT JSONCompactEachRow `;

  NUM_OF_LINE = 3396;

  getClickHouseClient = function() {
    var err, pathToConfig, profileConfig, profileName;
    profileName = process.env.CLICKHOUSE_CARGO_PROFILE;
    assert(profileName, "missing process.env.CLICKHOUSE_CARGO_PROFIL");
    if (path.extname(profileName) !== ".json") {
      profileName += ".json";
    }
    pathToConfig = path.join(os.homedir(), ".clickhouse-cargo", profileName);
    debuglog(`[getClickHouseClient] try auto init from CLICKHOUSE_CARGO_PROFILE from ${pathToConfig}`);
    try {
      profileConfig = JSON.parse(fs.readFileSync(pathToConfig));
    } catch (error) {
      err = error;
      debuglog("[static init] FAILED error:", err);
    }
    return new ClickHouse(profileConfig);
  };

  describe("restore-local-rotations", function() {
    var clickHouseClient, theCargo, theFilepath;
    this.timeout(60000);
    clickHouseClient = getClickHouseClient();
    theCargo = null;
    theFilepath = null;
    before(function(done) {
      clickHouseClient.query(STATEMENT_DROP_TABLE, function(err) {
        if (err != null) {
          throw err;
        }
        clickHouseClient.query(STATEMENT_CREATE_TABLE, done);
      });
    });
    after(function() {
      return process.exit(0);
    });
    it("prepare local rotations", function(done) {
      var arr, content, err, i, j, ref;
      try {
        theFilepath = path.join(process.cwd(), "cargo_files", `cargo_${TABLE_NAME}.${Date.now().toString(36)}_unittest.nocluster.uncommitted`);
        debuglog("[prepare] theFilepath:", theFilepath);
        content = "";
        for (i = j = 0, ref = NUM_OF_LINE; (0 <= ref ? j < ref : j > ref); i = 0 <= ref ? ++j : --j) {
          arr = [Math.round(Date.now() / 1000), i, columnValueString];
          content += JSON.stringify(arr) + "\n";
        }
        content = content.substr(0, content.length - 1);
        fs.writeFileSync(theFilepath, content);
        theCargo = createCargo(TABLE_NAME);
      } catch (error) {
        err = error;
        console.log("failed error:", err);
      }
      setTimeout(done, 20000); // wait for cargo.exam
    });
    it("local bulks should be commit to ClickHouse", function(done) {
      var rows;
      rows = [];
      debuglog("[read db] select:", STATEMENT_SELECT);
      clickHouseClient.query(STATEMENT_SELECT, {
        format: "JSONCompactEachRow"
      }, function(err, result) {
        var i, j, len, row;
        if (err != null) {
          done(err);
          return;
        }
        result = result.replace(/\n/g, ",").trim().replace(/,$/, '');
        result = `[ ${result} ]`;
        //console.dir result
        result = JSON.parse(result);
        debuglog("[read db] result:", result.length);
        //console.dir result, depth:10
        assert(result.length === NUM_OF_LINE, `unmatching row length local:${NUM_OF_LINE}, remote:${result.length}`);
        result.sort(function(a, b) {
          return a[1] - b[1];
        });
        for (i = j = 0, len = result.length; j < len; i = ++j) {
          row = result[i];
          assert(row[1] === i, "unmatching field 1 ");
          assert(row[2] === columnValueString, "unmatching field 2 ");
        }
        done();
      });
    });
    it("local bulks should be cleaned", function(done) {
      assert(fs.existsSync(theFilepath) === false, `local bulks should be cleaned:${theFilepath}`);
      done();
    });
  });

}).call(this);
